subroutine CalcEnergyWalls(Pos, NTypes, WallTypeOne, WallTypeTwo, M, L, rc, PEnergy, Dim, NAtom)
    implicit none
    integer, intent(in) :: M, Dim, NAtom, WallTypeOne, WallTypeTwo
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
    real(8), intent(in), dimension(0:NAtom-1) :: NTypes
    !real(8), intent(in), dimension(0:NWallAtom-1, 0:Dim-1) :: WallPos
    real(8), intent(in) :: L, rc
    real(8), intent(out) :: PEnergy
    real(8), parameter :: k = 3000., r0 = 1., pi = 3.14159265
    !======== YOUR CODE HERE ========
    real(8), dimension(Dim) :: rij, Posi
    real(8) :: d2, id2, id6, id12, iz3, iz9, z3, zij, ziL, zL3, izL3, izL9
    real(8) :: rc2, Shift, rij_scalar
    integer :: i, j
    !Compute the Lennard-Jones shift value before the pairwise loop
    Shift = -4. * (rc**(-12) - rc**(-6))
    rc2 = rc * rc
    PEnergy = 0.
    do i = 0, NAtom - 1
        !store Pos(i,:) in a temporary array for faster access in j loop
        Posi = Pos(i,:)
        zij = POS(i,2)
        ziL = zij - L
        z3 = zij * zij * zij
        zL3 = ziL * ziL * ziL
        iz3 = 1. / z3
        izL3 = 1. / zL3
        iz9 = iz3 * iz3 * iz3
        izL9 = izL3 * izL3 * izL3
        if ((zij < 5. .or. zij > (L-5.)) .and. (WallTypeOne == 0 .and. WallTypeTwo == 0) .and. (NTypes(i) == 0)) Then
	!IF (WallTypeOne == 0 .and. WallTypeTwo == 0) THEN
	    !epsw1 = 1.
            !epsw2 = 1.
	    !Place = 0.
            PEnergy = PEnergy + 200. * 0.74 * ((1./15.)*iz9-0.5*iz3)-50.*0.74*((1./15.)*izL9-0.5*izL3) ! full PE function
            !PEnergy = PEnergy + 1.0 * 0.74 * (-0.5*iz3)-1.0*0.74*(-0.5*izL3) ! attractive only PE function
            !PEnergy = PEnergy + 1.0 * 0.74 * ((1./15.)*iz9)-1.0*0.74*((1./15.)*izL9) ! repulsive only PE function
        !if ((zij < 5. .or. zij > (L-5.)) .and. (WallTypeOne == 0 .and. WallTypeTwo == 0)) Then
        ELSE IF ((zij < 5. .or. zij > (L-5.)) .and. (WallTypeOne == 1 .and. WallTypeTwo == 1) .and. (NTypes(i) == 1)) THEN
            !epsw1 = 0.01
            !epsw2 = 0.01
	    !Place = 0.
            PEnergy = PEnergy + 50. * 0.74 * ((1./15.)*iz9-0.5*iz3)-50.*0.74*((1./15.)*izL9-0.5*izL3)
            !PEnergy = PEnergy + 1.0 * 0.74 * (-0.5*iz3)-1.0*0.74*(-0.5*izL3) ! attractive only PE function
            !PEnergy = PEnergy + 1.0 * 0.74 * ((1./15.)*iz9)-1.0*0.74*((1./15.)*izL9) ! repulsive only PE function
        ELSE
            !epsw1 = 1.
            !epsw2 = 0.01
            !Place = 0.
            if ((zij < 5. .or. zij > (L-5.)) .and. (NTypes(i) == 0)) Then
                PEnergy = PEnergy + 200. * 0.74 * ((1./15.)*iz9-0.5*iz3)-50.*0.74*((1./15.)*izL9-0.5*izL3)
            ELSE if ((zij < 5. .or. zij > (L-5.)) .and. (NTypes(i) == 1)) Then
                PEnergy = PEnergy + 50. * 0.74 * ((1./15.)*iz9-0.5*iz3)-50.*0.74*((1./15.)*izL9-0.5*izL3)
            else
                PEnergy = PEnergy + 0.
            end if
	        !PEnergy = PEnergy + 1.0 * 0.74 * (-0.5*iz3)-1.0*0.74*(-0.5*izL3) ! attractive only PE function
                !PEnergy = PEnergy + 1.0 * 0.74 * ((1./15.)*iz9)-1.0*0.74*((1./15.)*izL9) ! repulsive only PE function
        END If
        !PEnergy = PEnergy + epsw1 * 0.74 * ((1./15.)*iz9-0.5*iz3)-epsw2*0.74*((1./15.)*izL9-0.5*izL3)
        do j = i + 1, NAtom - 1
            if (j == i + 1 .and. mod(j, M) > 0) then
                !this is a bonded interaction;
		!use the harmonic bond potential here
                rij = Pos(j,:) - Posi
                rij(:2)= rij(:2) - L * dnint(rij(:2) / L)
                !rij= rij - L * dnint(rij / L)
                rij_scalar = sqrt(sum(rij * rij))
                PEnergy = PEnergy + (k * 0.5) * (rij_scalar-r0) ** 2.
            else
                !this is a nonbounded interaction;
            	!use the Lennard-Jones potential here
                rij = Pos(j,:) - Posi
                rij(:2)= rij(:2) - L * dnint(rij(:2) / L)
                !rij= rij - L * dnint(rij / L)
		!Compute only the squared distance and compare to the square cut                
                d2 = sum(rij * rij)
                if (d2 > rc2) then
                    cycle
                end if
                id2 = 1. / d2            !inverse squared distance
                id6 = id2 * id2 * id2    !inverse sixth distance
                id12 = id6 * id6         !inverse twelvth distance
                !Calculate the PEnergy, U
                if (NTypes(i) == NTypes(j) .and. NTypes(j) == 0) THEN
                    !eps = 1.
                    PEnergy = PEnergy + 4. *1.0* (id12 - id6) + Shift
                ELSE
		    !eps = 0.01
                    PEnergy = PEnergy + 4. *0.1* (id12 - id6) + Shift
                End if
                !PEnergy = PEnergy + 4. *eps* (id12 - id6) + Shift
                end if
        enddo
    enddo   

end subroutine

subroutine CalcEnergy(Pos, NTypes, M, L, rc, PEnergy, Dim, NAtom)
    implicit none
    integer, intent(in) :: M, Dim, NAtom
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
    real(8), intent(in), dimension(0:NAtom-1) :: NTypes
    !real(8), intent(in), dimension(0:NWallAtom-1, 0:Dim-1) :: WallPos
    real(8), intent(in) :: L, rc
    real(8), intent(out) :: PEnergy
    real(8), parameter :: k = 3000., r0 = 1., pi = 3.14159265
    !======== YOUR CODE HERE ========
    real(8), dimension(Dim) :: rij, Posi
    real(8) :: d2, id2, id6, id12
    real(8) :: rc2, Shift, rij_scalar
    integer :: i, j
    !Compute the Lennard-Jones shift value before the pairwise loop
    Shift = -4. * (rc**(-12) - rc**(-6))
    rc2 = rc * rc
    PEnergy = 0.
    do i = 0, NAtom - 1
        !store Pos(i,:) in a temporary array for faster access in j loop
        Posi = Pos(i,:)
        
        do j = i + 1, NAtom - 1
            if (j == i + 1 .and. mod(j, M) > 0) then
                !this is a bonded interaction;
		!use the harmonic bond potential here
                rij = Pos(j,:) - Posi
                rij(:2)= rij(:2) - L * dnint(rij(:2) / L)
                !rij= rij - L * dnint(rij / L)
                rij_scalar = sqrt(sum(rij * rij))
                PEnergy = PEnergy + (k * 0.5) * (rij_scalar-r0) ** 2.
            else
                !this is a nonbounded interaction;
            	!use the Lennard-Jones potential here
                rij = Pos(j,:) - Posi
                rij(:2)= rij(:2) - L * dnint(rij(:2) / L)
                !rij= rij - L * dnint(rij / L)
		!Compute only the squared distance and compare to the square cut                
                d2 = sum(rij * rij)
                if (d2 > rc2) then
                    cycle
                end if
                id2 = 1. / d2            !inverse squared distance
                id6 = id2 * id2 * id2    !inverse sixth distance
                id12 = id6 * id6         !inverse twelvth distance
                !Calculate the PEnergy, U
                if (NTypes(i) == NTypes(j) .and. NTypes(j) == 0) THEN
                    !eps = 1.
                    PEnergy = PEnergy + 4. *1.0* (id12 - id6) + Shift
                ELSE
		    !eps = 0.01
                    PEnergy = PEnergy + 4. *0.1* (id12 - id6) + Shift
                End if
                !PEnergy = PEnergy + 4. *eps* (id12 - id6) + Shift
                end if
        enddo
    enddo   

end subroutine

subroutine CalcEnergyForcesWalls(Pos, NTypes, WallTypeOne, WallTypeTwo, M, L, rc, PEnergy, Forces, Dim, NAtom)
    implicit none
    integer, intent(in) :: M, Dim, NAtom, WallTypeOne, WallTypeTwo
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
    real(8), intent(in), dimension(0:NAtom-1) :: NTypes
    !real(8), intent(in), dimension(0:NWallAtom-1, 0:Dim-1) :: WallPos
    real(8), intent(in) :: L, rc
    real(8), intent(out) :: PEnergy
    real(8), intent(inout), dimension(0:NAtom-1, 0:Dim-1) :: Forces
!f2py intent(in, out, inplace) :: Forces
    real(8), parameter :: k = 3000., r0 = 1., pi = 3.14159265
    !======== YOUR CODE HERE ========
    real(8), dimension(Dim) :: rij, Fij, Posi
    real(8) :: d2, id2, id6, id12, z2, z3, iz3, iz9, zij, zL3, izL3, izL9, ziL, ziL2
    real(8) :: rc2, Shift, rij_scalar
    integer :: i, j
    !Compute the Lennard-Jones shift value before the pairwise loop
    Shift = -4. * (rc**(-12) - rc**(-6))
    rc2 = rc * rc
    PEnergy = 0.
    Forces = 0.
    do i = 0, NAtom - 1
        !store Pos(i,:) in a temporary array for faster access in j loop
        Posi = Pos(i,:)
        zij = POS(i,2)
        ziL = zij - L
        ziL2 = ziL * ziL
        z2 = zij * zij
        z3 = zij * zij * zij
        iz3 = 1. / z3
        zL3 = ziL * ziL * ziL
        izL3 = 1. / zL3
        iz9 = iz3 * iz3 * iz3
        izL9 = izL3 * izL3 * izL3
        IF (NTypes(i) == 0) THEN
            IF (WallTypeOne == 0 .and. WallTypeTwo == 0) Then
                PEnergy = PEnergy + 150. * 0.74 * ((1./15.)*iz9-0.5*iz3)-150.*0.74*((1./15.)*izL9-0.5*izL3)
                Forces(i,2) = Forces(i,2) - 150. * 0.74 *((-9./15.)*iz9+1.5*iz3)*iz3*z2+150.*0.74*((-9./15.)*izL9+1.5*izL3)*izL3*ziL2 ! full force function
            Else if (WallTypeOne == 0 .and. WallTypeTwo == 1) THEN
                PEnergy = PEnergy + 150. * 0.74 * ((1./15.)*iz9-0.5*iz3)-15.*0.74*((1./15.)*izL9-0.5*izL3)
                Forces(i,2) = Forces(i,2) - 150. * 0.74 *((-9./15.)*iz9+1.5*iz3)*iz3*z2+15.*0.74*((-9./15.)*izL9+1.5*izL3)*izL3*ziL2
            else if (WallTypeOne == 1 .and. WallTypeTwo == 0) Then
                PEnergy = PEnergy + 15. * 0.74 * ((1./15.)*iz9-0.5*iz3)-150.*0.74*((1./15.)*izL9-0.5*izL3)
                Forces(i,2) = Forces(i,2) - 15. * 0.74 *((-9./15.)*iz9+1.5*iz3)*iz3*z2+150.*0.74*((-9./15.)*izL9+1.5*izL3)*izL3*ziL2
            ELSE
                PEnergy = PEnergy + 15. * 0.74 * ((1./15.)*iz9-0.5*iz3)-15.*0.74*((1./15.)*izL9-0.5*izL3)
                Forces(i,2) = Forces(i,2) - 15. * 0.74 *((-9./15.)*iz9+1.5*iz3)*iz3*z2+15.*0.74*((-9./15.)*izL9+1.5*izL3)*izL3*ziL2
            end if
        ELSE
            PEnergy = PEnergy + 15. * 0.74 * ((1./15.)*iz9-0.5*iz3)-15.*0.74*((1./15.)*izL9-0.5*izL3)
            Forces(i,2) = Forces(i,2) - 15. * 0.74 *((-9./15.)*iz9+1.5*iz3)*iz3*z2+15.*0.74*((-9./15.)*izL9+1.5*izL3)*izL3*ziL2
        end if
        !PEnergy = PEnergy + epsw1 * 0.74 * ((1./15.)*iz9-0.5*iz3)-epsw2*0.74*((1./15.)*izL9-0.5*izL3)
        !Forces(i,2) = Forces(i,2) - epsw1 * 0.74 *((-9./15.)*iz9+1.5*iz3)*iz3*ziL2+epsw2*0.74*((-9./15.)*izL9+1.5*izL3)*izL3*ziL2
        !Forces(i,2) = Forces(i,2) - epsw1 * 0.74 *((-9./15.)*iz9+1.5*iz3)*iz3*ziL2+epsw2*0.74*((-9./15.)*izL9+1.5*izL3)*izL3*ziL2
	!PEnergy = PEnergy + Con * eps * (0.0666667 * iz9 - 0.5 * iz3)-Con*eps*(0.0666667*iz9-0.5*iz3+con9+con3)
        !Forces(i,2)=Forces(i,2)+Con*eps*(-9.*0.0667*iz9+3*0.5*iz3)*iz3*z2-Con*eps*((-9*0.0667*iz9+3*0.5*iz3)*iz3*z2+con9/L+con3/L)
	!!!Forces(i,2) = Forces(i,2) + 8. * pi * 1. * 0.74 * (-9. * iz9 + 3. * iz3) * iz3 * z2
	
        do j = i + 1, NAtom - 1
            if (j == i + 1 .and. mod(j, M) > 0) then
            	!this is a bonded interaction;
		!use the harmonic bond potential here
                rij = Pos(j,:) - Posi
                rij(:2)= rij(:2) - L * dnint(rij(:2) / L)
		!rij= rij - L * dnint(rij / L)
                rij_scalar = sqrt(sum(rij * rij))
                PEnergy = PEnergy + (k * 0.5) * (rij_scalar-r0) ** 2.
                Fij = k * (rij_scalar- r0) * rij / rij_scalar
                Forces(i,:) = Forces(i,:) + Fij
                Forces(j,:) = Forces(j,:) - Fij
            else
		!this is a nonbounded interaction;
		!use the Lennard-Jones potential here
                rij = Pos(j,:) - Posi
                !rij(:2)= rij(:2) - L * dnint(rij(:2) / L)
                rij(:2)= rij(:2) - L * dnint(rij(:2) / L)
		!Compute only the squared distance and compare to the square cut                
                d2 = sum(rij * rij)
                if (d2 > rc2) then
                    cycle
                end if
                id2 = 1. / d2            !inverse squared distance
                id6 = id2 * id2 * id2    !inverse sixth distance
                id12 = id6 * id6         !inverse twelvth distance
                !Calculate the PEnergy, U, and Force from W,the virial
                if (NTypes(i) == NTypes(j) .and. NTypes(i) == 0) THEN
                    !eps = 1.
                    PEnergy = PEnergy + 4. *1.0* (id12 - id6) + Shift
                    Fij = rij *1.0* ((-48. * id12 + 24. * id6) * id2)
                ELSE
                    !eps = 0.01
                    PEnergy = PEnergy + 4. *0.1* (id12 - id6) + Shift
                    Fij = rij *0.1* ((-48. * id12 + 24. * id6) * id2)
                End if
                !PEnergy = PEnergy + 4. *eps* (id12 - id6) + Shift
                !Fij = rij *eps* ((-48. * id12 + 24. * id6) * id2)
                Forces(i,:) = Forces(i,:) + Fij
                Forces(j,:) = Forces(j,:) - Fij    
            end if
        enddo
    enddo
end subroutine

subroutine CalcEnergyForces(Pos, NTypes, M, L, rc, PEnergy, Forces, Dim, NAtom)
    implicit none
    integer, intent(in) :: M, Dim, NAtom
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
    real(8), intent(in), dimension(0:NAtom-1) :: NTypes
    !real(8), intent(in), dimension(0:NWallAtom-1, 0:Dim-1) :: WallPos
    real(8), intent(in) :: L, rc
    real(8), intent(out) :: PEnergy
    real(8), intent(inout), dimension(0:NAtom-1, 0:Dim-1) :: Forces
!f2py intent(in, out, inplace) :: Forces
    real(8), parameter :: k = 3000., r0 = 1., pi = 3.14159265
    !======== YOUR CODE HERE ========
    real(8), dimension(Dim) :: rij, Fij, Posi
    real(8) :: d2, id2, id6, id12
    real(8) :: rc2, Shift, rij_scalar
    integer :: i, j
    !Compute the Lennard-Jones shift value before the pairwise loop
    Shift = -4. * (rc**(-12) - rc**(-6))
    rc2 = rc * rc
    PEnergy = 0.
    Forces = 0.
    do i = 0, NAtom - 1
        !store Pos(i,:) in a temporary array for faster access in j loop
        Posi = Pos(i,:)
                
        do j = i + 1, NAtom - 1
            if (j == i + 1 .and. mod(j, M) > 0) then
            	!this is a bonded interaction;
		!use the harmonic bond potential here
                rij = Pos(j,:) - Posi
                rij(:2)= rij(:2) - L * dnint(rij(:2) / L)
		!rij= rij - L * dnint(rij / L)
                rij_scalar = sqrt(sum(rij * rij))
                PEnergy = PEnergy + (k * 0.5) * (rij_scalar-r0) ** 2.
                Fij = k * (rij_scalar- r0) * rij / rij_scalar
                Forces(i,:) = Forces(i,:) + Fij
                Forces(j,:) = Forces(j,:) - Fij
            else
		!this is a nonbounded interaction;
		!use the Lennard-Jones potential here
                rij = Pos(j,:) - Posi
                !rij(:2)= rij(:2) - L * dnint(rij(:2) / L)
                rij(:2)= rij(:2) - L * dnint(rij(:2) / L)
		!Compute only the squared distance and compare to the square cut                
                d2 = sum(rij * rij)
                if (d2 > rc2) then
                    cycle
                end if
                id2 = 1. / d2            !inverse squared distance
                id6 = id2 * id2 * id2    !inverse sixth distance
                id12 = id6 * id6         !inverse twelvth distance
                !Calculate the PEnergy, U, and Force from W,the virial
                if (NTypes(i) == NTypes(j) .and. NTypes(j) == 0) THEN
                    !eps = 1.
                    PEnergy = PEnergy + 4. *1.0* (id12 - id6) + Shift
                    Fij = rij *1.0* ((-48. * id12 + 24. * id6) * id2)
                ELSE
                    !eps = 0.01
                    PEnergy = PEnergy + 4. *0.1* (id12 - id6) + Shift
                    Fij = rij *0.1* ((-48. * id12 + 24. * id6) * id2)
                End if
                !PEnergy = PEnergy + 4. *eps* (id12 - id6) + Shift
                !Fij = rij *eps* ((-48. * id12 + 24. * id6) * id2)
                Forces(i,:) = Forces(i,:) + Fij
                Forces(j,:) = Forces(j,:) - Fij    
            end if
        enddo
    enddo
end subroutine

subroutine VVIntegrateWalls(Pos, NTypes, WallTypeOne, WallTypeTwo, Vel, Accel, M, L, rc, dt, KEnergy, PEnergy, Dim, NAtom)
    implicit none
    integer, intent(in) :: M, Dim, NAtom, WallTypeOne, WallTypeTwo
    real(8), intent(in) :: L, rc, dt
    real(8), intent(in), dimension(0:NAtom-1) :: NTypes
    real(8), intent(inout), dimension(0:NAtom-1, 0:Dim-1) :: Pos, Vel, Accel
    !real(8), intent(in), dimension(0:NWallAtom-1, 0:Dim-1) :: WallPos
!f2py intent(in,out,inplace) :: Pos, Vel, Accel
    real(8), intent(out) :: KEnergy, PEnergy
    external :: CalcEnergyForcesWalls
    Pos = Pos + dt * Vel + 0.5 * dt*dt * Accel
    Vel = Vel + 0.5 * dt * Accel
    call CalcEnergyForcesWalls(Pos, NTypes, WallTypeOne, WallTypeTwo, M, L, rc, PEnergy, Accel, Dim, NAtom)
    Vel = Vel + 0.5 * dt * Accel
    KEnergy = 0.5 * sum(Vel*Vel)
end subroutine

subroutine VVIntegrate(Pos, NTypes, Vel, Accel, M, L, rc, dt, KEnergy, PEnergy, Dim, NAtom)
    implicit none
    integer, intent(in) :: M, Dim, NAtom
    real(8), intent(in) :: L, rc, dt
    real(8), intent(in), dimension(0:NAtom-1) :: NTypes
    real(8), intent(inout), dimension(0:NAtom-1, 0:Dim-1) :: Pos, Vel, Accel
    !real(8), intent(in), dimension(0:NWallAtom-1, 0:Dim-1) :: WallPos
!f2py intent(in,out,inplace) :: Pos, Vel, Accel
    real(8), intent(out) :: KEnergy, PEnergy
    external :: CalcEnergyForces
    Pos = Pos + dt * Vel + 0.5 * dt*dt * Accel
    Vel = Vel + 0.5 * dt * Accel
    call CalcEnergyForces(Pos, NTypes, M, L, rc, PEnergy, Accel, Dim, NAtom)
    Vel = Vel + 0.5 * dt * Accel
    KEnergy = 0.5 * sum(Vel*Vel)
end subroutine